happyreport/urls.py
from django.contrib import admin
from django.urls import path, include


urlpatterns = [
    path('admin/', admin.site.urls),
    path('app/',   include('web.urls', namespace='web')),

]

web/urls.py
from django.urls import path
from . import views
app_name = "web"

urlpatterns = [
    path("main-report", views.home, name="main-report"),
    path("regional_report", views.regional_report, name="regional_report"),
    path("yearly-report", views.yearly_report, name="yearly-report")
]

happyreport/models/coutryreport.py
from .region import Region
import numpy as np


class CountryReport:
    # Class attribute

    def __init__(self, countryName, ladder_score, scores):
        super().__init__()
        self.countryName = countryName
        self.ladder_score = ladder_score
        # make all score to scale 100
        self.scores = np.array(scores) * 10
        self.region = None

happyreport/models/region.py
class Region:
    # Class attribute

    def __init__(self, regionName):
        super().__init__()
        self.regionName = regionName
        self.countries = []

web/models.py
from django.db import models

# Create your models here.

web/views.py
from django.shortcuts import render
from django.http import HttpResponse
from dependency_injector.wiring import inject, Provide

from happyreport.ioc.containers import Container
from happyreport.ioc.services import DataService
from happyreport.file.excelreader import ExcelReader

colors = ['#95348F', '#EC008C', '#FD642B', '#DCF400',
          '#65C9D1', '#848CC6', '#BB9CCA', '', '']

# Main View to display data


def home(request,
         data_service: DataService = Provide[Container.data_service],):
    data, _ = data_service.loadData()

    return render(request, "main-report.html", {'model': data, 'colors': colors})


# report by regions
def regional_report(request,
                    data_service: DataService = Provide[Container.data_service],):

    data, region = data_service.loadData()

    return render(request, "regional-report.html", {'model': region,  'colors': colors})


def yearly_report(request,
                  data_service: DataService = Provide[Container.data_service],):

    data, years = data_service.loadYearlyData()

    if request.method == 'POST':
        # get  year filter
        year = request.POST.get('years-filter')
        # filter the data by year
        data = data_service.queryDataByYear(year)
    else:
        # set to smallest year
        year = 'No year selected'

    return render(request, "yearly-report.html", {'model': data, 'years': years, 'year': year, 'colors': colors})

templates/base.html
{% load static %}
<!DOCTYPE html>
<html>

<head>
    <title>My Project</title>

    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet"
        integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">

    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-MrcW6ZMFYlzcLA8Nl+NtUVF0sA7MsXsP1UyJoMp4YLEuNSfAP+JcXn/tWtIaxVXM"
        crossorigin="anonymous"></script>

    <link rel="stylesheet" type="text/css" href="{% static 'css/style.css' %}">
</head>


<body>
    <div class="container p-4">
        <div class="shadow p-3 mb-5 bg-body rounded">
            <h1>Happiness Report</h1>
            <a class="btn btn-primary m-1" href="/app/main-report" role="button">2021 Happiness Report</a>
            <a class="btn btn-info m-1" href="/app/yearly-report" role="button">Report by year</a>
            <a class="btn btn-warning m-1" href="/app/regional_report" role="button">Report by Region</a>
        </div>


        <div class="shadow p-3 mb-5 bg-body rounded">
            {% block content %}{% endblock %}
        </div>
    </div>


</body>

</html>

web/templates/main-report.html
{% extends "base.html" %}
{% load mathfilters %}


{% block content %}
<div class="p-4">
    <ol>
        {% for item in model %}
        <li>
            <div style="display: flex;">
                <div style="width: 250px;">
                    {{ item.countryName }} ({{ item.ladder_score }})
                </div>
                <div style="flex: 1 1 auto;">
                    {% for score in item.scores %}

                    <div class="indicator"
                        style="width: {{score}}%;background-color: {% cycle colors.0 colors.1 colors.2 colors.3 colors.4 colors.5 colors.6 as color %}">
                        {{score|div:10}}
                    </div>

                    {% endfor %}

                </div>
            </div>
            <hr />
        </li>

        {% endfor %}
    </ol>
</div>
{% endblock %}

web/templates/regional-report.html
{% extends "base.html" %}
{% load mathfilters %}


{% block content %}
<div class="p-4">
    <ul class="list-group">
        {% for region in model %}
        <li class="list-group-item">
            <h4>{{region.regionName}}</h4>
            <ol class="list-group">
                {% for item in region.countries %}
                <li class="list-group-item">
                    <div style="display: flex;">
                        <div style="width: 250px;">
                            {{ forloop.counter }}.&nbsp;{{ item.countryName }} ({{ item.ladder_score }})
                        </div>
                        <div style="flex: 1 1 auto;">
                            {% for score in item.scores %}

                            <div class="indicator"
                                style="width: {{score}}%;background-color: {% cycle colors.0 colors.1 colors.2 colors.3 colors.4 colors.5 colors.6 as color %}">
                                {{score|div:10}}
                            </div>

                            {% endfor %}

                        </div>
                    </div>
                </li>

                {% endfor %}
            </ol>

        </li>
        {% endfor %}
    </ul>
</div>
{% endblock %}

web/templates/yearly-report.html
{% extends "base.html" %}
{% load mathfilters %}


{% block content %}
<div class="p-4">
    <form action="{% url 'web:yearly-report' %}" method="POST">
        {% csrf_token %}
        <label>
            Filter Report By Year
        </label>
        <select id="year-select" name="years-filter" class="form-select" aria-label="Filter Year"
            onchange="this.form.submit();">
            <option disabled selected> -- select a year -- </option>
            {% for y in years %}
            <option name="year" value={{y}}>{{y}}</option>
            {% endfor %}

        </select>

    </form>
    <h3>Report of year:{{year}}</h3>
    <ol>
        {% for item in model %}
        <li>
            <div style="display: flex;">
                <div style="width: 250px;">
                    {{ item.countryName }} ({{ item.ladder_score }})
                </div>
                <div style="flex: 1 1 auto;">
                    {% for score in item.scores %}

                    <div class="indicator"
                        style="width: {{score}}%;background-color: {% cycle colors.0 colors.1 colors.2 colors.3 colors.4 colors.5 colors.6 as color %}">
                        {{score|div:10}}
                    </div>

                    {% endfor %}

                </div>
            </div>
            <hr />
        </li>

        {% endfor %}
    </ol>
</div>
{% endblock %}